#vsalida.py: Ventana que muestra los resultados de las operaciones solicitadas

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#self.archivoAbrirAction
#self.archivoGuardarAction
#self.archivoGuardar_comoAction
#self.exportarAction
#self.toolbar: toolbar
#self.texBrowser1: Zona que muestra contenido html

from uivsalida import VentanaSalida
from qt import *

class VSalida(VentanaSalida):
	"""Dialogo que muestra los resultados de las operaciones solicitadas"""
	def __init__(self,name = "Salida",modal = 0, fl = 0):
		VentanaSalida.__init__(self)
		self.contenido = []
		self.__inittoolbar()
		self.__conexiones()

	def __inittoolbar(self):
		"""Inicializa la toolbar"""
		self.boton1=QToolButton(self.Toolbar)
		self.boton1.setTextLabel("ABRIR")
	 	iconos=QIconSet()
		iconos.setIconSize(QIconSet.Small,QSize(100,100))
		iconos.setPixmap("images/botonabrir.png",QIconSet.Small)
		self.boton1.setOn(True)
		self.boton1.setIconSet(iconos)
		self.boton2=QToolButton(self.Toolbar)
		self.boton2.setTextLabel("GUARDAR")
	 	iconos=QIconSet()
		iconos.setIconSize(QIconSet.Small,QSize(100,100))
		iconos.setPixmap("images/botonguardar.png",QIconSet.Small)
		self.boton2.setOn(True)
		self.boton2.setIconSet(iconos)
		self.boton3=QToolButton(self.Toolbar)
		self.boton3.setTextLabel("GUARDAR")
	 	iconos=QIconSet()
		iconos.setIconSize(QIconSet.Small,QSize(100,100))
		iconos.setPixmap("images/botonexportar.png",QIconSet.Small)
		self.boton3.setOn(True)
		self.boton3.setIconSet(iconos)

	def __conexiones(self):
		"""Bloque de conexiones"""
		self.connect(self.archivoAbrirAction,SIGNAL("activated()"),self.__abrirfichero)
		self.connect(self.archivoGuardarAction,SIGNAL("activated()"),self.__guardarfichero)
		self.connect(self.archivoExportarHTMLAction,SIGNAL("activated()"),self.__exportar)
		self.connect(self.archivoSalirAction,SIGNAL("activated()"),self.__salir)
		self.connect(self.boton1,SIGNAL("clicked()"),self.__abrirfichero)
		self.connect(self.boton2,SIGNAL("clicked()"),self.__guardarfichero)
		self.connect(self.boton3,SIGNAL("clicked()"),self.__exportar)


	def app_obj(self,objeto):
		self.contenido.append(objeto)
	def show(self):
		"""Redefinicion del método show de VentanaSalida"""
		cadenasalida=""
		for resultado in self.contenido:
			cadenasalida+=resultado.html()
		self.textBrowser1.setText(cadenasalida)
		VentanaSalida.show(self)
	def __salir(self):
		"""Salida del dialogo"""
		self.hide()
	def __abrirfichero(self):		
		import string
		filter=""
		for fmt in ["dro"]: #Candidata al fichero de listas
			filter=filter+"%s files (*.%s);;" % (fmt,string.lower(fmt))
		fn = QFileDialog.getOpenFileName(QString.null,filter,self,None,"Dialogo abrir fichero","")
		filename = str(fn)
		if filename:
			self.cargarfichero(filename)

	def cargarfichero(self,fichero):
		import re
		regexp=re.compile('.*\.dro$')
		archivo = open(fichero, 'r')
		if regexp.match(fichero):
			import pickle
			self.contenido=pickle.load(archivo)
		self.show()
	
	def __guardarfichero(self):
		fn = QFileDialog.getSaveFileName(QString.null,QString.null,self)
		filename = str(fn)
		if filename:
			self.guardarfichero(filename)

	def guardarfichero(self,fichero):
		import re
		regexp=re.compile('.*\.dro$')
		archivo = open(fichero, 'w')
		if regexp.match(fichero):
			import pickle
			pickle.dump(self.contenido,archivo)
	

	def __exportar(self):
		fn = QFileDialog.getSaveFileName(QString.null,QString.null,self)
		filename = str(fn)
		if filename:
			self.exportar(filename)
	def exportar(self,fichero):
		import re
		regexp=re.compile('.*\.html$')
		archivo = open(fichero, 'w')
		if regexp.match(fichero):
			cadenasalida=""
			for resultado in self.contenido:
				cadenasalida+=resultado.html()
			archivo.write (cadenasalida)


